// https://de.wikipedia.org/wiki/Y2K-Spiel

class Spielfeld {
	char[] felder;

	Spielfeld(int groesse) {
		felder = new char[groesse];
		for (int i = 0; i < felder.length; i++) {
			felder[i] = '.';
		}
	}

	int getGroesse() {
		return felder.length;
	}

	void print() {
		System.out.println(new String(felder));
	}

	boolean spielzugMoeglich() {
		for (int i = 0; i < felder.length; i++) {
			if (felder[i] == '.') {
				return true;
			}
		}
		return false;
	}

	void spielzugAusfuehren(Spielzug zug) {
		felder[zug.getIndex()] = zug.getBuchstabe();
	}

	boolean spielende() {
		return new String(felder).contains("SOS");
	}

	char getBuchstabe(int index) {
		return felder[index];
	}
}

class Spielzug {
	int index;
	char buchstabe;

	Spielzug(int index, char buchstabe) {
		this.index = index;
		this.buchstabe = buchstabe;
	}

	int getIndex() {
		return index;
	}

	char getBuchstabe() {
		return buchstabe;
	}

}

public class UE9Aufgabe15OO {

	public static void main(String[] args) {
		// Initialisierungen
		final int GROESSE = 20;
		Spielfeld spielfeld = new Spielfeld(GROESSE);
		spielfeld.print();
		int spieler = 0;
		while (spielfeld.spielzugMoeglich()) {
			Spielzug zug = spielzugEingeben(spielfeld, spieler);
			spielfeld.spielzugAusfuehren(zug);
			spielfeld.print();
			if (spielfeld.spielende()) {
				System.out.println("Spieler " + (spieler + 1) + " hat gewonnen!");
				return;
			}
			spieler = (spieler + 1) % 2; // Spielerwechsel
		}
		System.out.println("Unentschieden!");
	}

	static Spielzug spielzugEingeben(Spielfeld spielfeld, int spieler) {
		System.out.println("Spieler " + (spieler + 1) + " ist am Zug!");
		int index = IO.readInt("Index eingeben: ");
		while (index < 0 || index >= spielfeld.getGroesse() || spielfeld.getBuchstabe(index) != '.') {
			index = IO.readInt("Ungueltiger Index! Index eingeben: ");
		}
		char buchstabe = IO.readChar("S oder O eingeben: ");
		while (buchstabe != 'S' && buchstabe != 'O') {
			buchstabe = IO.readChar("Ungueltiger Buchstabe! S oder O eingeben: ");
		}
		return new Spielzug(index, buchstabe);
	}

}
